/************************************************************************************
 * @Copyright (c)    :(C)2021, Qindao ieslab Co., Ltd
 * @FileName         :nb_uart_driver.h
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.1
 * @Date             :2021-07
 * @Description      :
 ************************************************************************************/

#ifndef __BLE_UART_DRIVER_H
#define	__BLE_UART_DRIVER_H

#include "ddl.h"
#include "type.h"
#include "UWater_uart_driver.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define BLE_TX_PORT			LPUART1_TX_PORT		//ڷ
#define BLE_TX_PIN			LPUART1_TX_PIN
#define BLE_RX_PORT			LPUART1_RX_PORT		//ڽ
#define BLE_RX_PIN			LPUART1_RX_PIN
#define BLE_LP_COM			1					//ǷΪLPUART1ǣ0ڶӦ
#define BLE_UART_REALCOM	M0P_LPUART1			//ײĴĴڣб봮ģĶ

#define BLE_AT_RCV_BUF_SIZE		64
#define BLE_AT_SCAN_MAC_TOTAL	20					//ɨ軺

//UARTѯ״̬Ϣ
#define BLE_UART_ING          	((s8)-1)           	//ѯ
#define BLE_UART_FINISH         ((s8)-2)           	//
#define BLE_UART_ERROR          ((s8)-3)           	//֡
#define BLE_UART_OK             ((s8)-4)          	//ȷ֡

#define BLE_UP_BUF_SIZE     256
#define BLE_AT_UP_BUF_SIZE          50
/*************************************ͨʹ궨******************************************/
//ڽ״̬е״̬BLE_S0-BLE_S10
enum{
	BLE_S0 = 10	,
	BLE_S1		,
	BLE_S2		,
	BLE_S3		,
	BLE_S4		,
	BLE_S5		,
	BLE_S6		,
	BLE_S7		,
	BLE_S8		,
	BLE_S9		,
	BLE_S10		,
};



enum
{
	BLE_cst_AT_NOMAL_RCV = 0,//͸
	BLE_cst_AT_OK_ERROR		,//ȷ
	BLE_cst_AT_AT			,//AT?
	BLE_cst_AT_QUERY		,
	BLE_cst_AT_SCAN_RCV		,//ɨ
};


//ͨŽṹ
typedef struct
{
	u16 send_len;		//¼͵ܳ
	u16 send_count;		//¼͵ĵǰλ
	u8 *send_buf;		//ͻ׵ַ
	u8 send_style;		//¼ָȷӦշʽ
	s8 rev_ack_flag;	//״̬־λ
	u8 ble_rcv_flag;	//յ͸
	u8 ble_rev_buf[BLE_UP_BUF_SIZE];
	u16 ble_rcv_len;
//	u16 rev_len;		//ݳ
} BLE_UART_COMM;

typedef struct
{
	u8 mac[6];			//MACַ
	u8 adv_data[11];	//㲥
	mtype16_ rssi;			//ź
} BLE_SLAVE_INFO, *P_BLE_SLAVE_INFO;

//******************************* ⲿ***************************************



//******************************* ⲿӿں***********************************
//#define NBUartReceiveIT BleUartReceiveIT
void BleUartSend(u8 *buf, u16 len, u8 style);
s8 BleCheckAtAck(void);
u8 BleUartChkStyle(void);
void BleUartChangeStyle(u8 style);
void BleUartReceiveIT(void);
u8 BleRcvAtData(u8 **p_data);

#if BLE_CENTRAL_SLAVE_MOD
void BleClrMacBuf(void);			//ɨ軺
u8 BleGetScanDevInfo(BLE_SLAVE_INFO **p_data);//ȡɨ赽豸Ϣ
u8 BleGetScanCompleteFlag(void);
void BleClrScanCompleteFlag(void);
#endif

u8 BleRcvFrameDataFlag(void);
void BleClrRcvFrameDataFlag(void);
void BleGetUartRcvData(u8 **rev_data,u16 *data_len);
u8 BleCheckIfResetFlag(void);
void BleClrIfResetFlag(void);

#ifdef __cplusplus
}
#endif

#endif	/* __BLE_UART_DRIVER_H */

